
n=5000;
% degrs de libert de la loi de Cauchy
nu=12;
% initialisation
m1=zeros(1,n);
m2=zeros(1,n);
m3=zeros(1,n);

% Mthode 1 : simulation suivant la loi de student
x=trnd(nu,1,n);

for i=1:n-1000;
test=x(1:i+1000);   
indices=find(test>2.1);
y=test(indices);
m1(i)=sum(y.^5)/(i+1000);
end

% Mthode 2 : loi de Cauchy
x=trnd(1,1,n);
for i=1:n-1000;
test=x(1:i+1000);   
indices=find(test>2.1);
y=x(indices);
z=(y.^5).*tpdf(y,nu)./tpdf(y,1);
m2(i)=sum(z)/(1000+i);
end


% Mthode 3 : loi uniforme
x=rand(1,n)./(2.1);
z=x.^(-7).*tpdf(1./x,nu);
for i=1:n-1000;
m3(i)=mean(z(1:i+1000))/2.1;
end


% figure
figure
plot(m1(1:n-1000))
hold on
plot(m2(1:n-1000),'r')
plot(m3(1:n-1000),'k')
XLABEL('iterations')
YLABEL('intgrale')
legend('Simulation suivant f','Importance Sampling (Loi de Cauchy avec \nu = 1)','Importance Sampling (Loi uniforme sur [0, 1/(2.1)])',0)
hold off
% print -depsc integrales_student

% Remarque : des programmes similaires sont disponible  l'adresse
% http://www.stat.wisc.edu/~mchung/teaching/stat471/stat471.html


