res=[];
% nombre de points
n=5000;
alpha=2.43;
beta=1;
b=2.43/2;
a=2;
% borne sup M
M=exp(-a*(log(a)-1)+alpha*(log(alpha)-1));

% gnration de y_1,...,y_n
y=gamrnd(a,b,1,n);

% tirages uniformes sur [0,1]
u=rand(1,n);

% rapport
ratio=gampdf(y,alpha,1)./(gampdf(y,a,b)*M);

% valeurs de x_i distribues suivant la loi gamma  simuler
for i=1:n
indices=find(u(1:i)<ratio(1:i));
z=y(indices).^2;
integrale(i)=mean(z);
end

% gnration  l'aide de Metropolis-Hastings
% Nombre de simulations de Monte-Carlo : n

% Initialisation
x0=gamrnd(a,b);

% Metropolis Hastings Nc iterations
Nc=10;
for i=1:n,
	% gnration 
 	inter=y(i);
        % calcul de l'cart
	delta=(a-alpha)*(log(inter/x0)+(x0-inter)/alpha);
	% T=1 pour l'algorithme de Metropolis Hastings
	if (delta < 0.0 | exp(-delta)>rand)
        % on accepte la valeur gnre par la loi de proposition
		x(i)=inter;
    else
        % on rejette la valeur gnre par la loi de proposition
        x(i)=x0;
    end
    x0=x(i);
    % calcul de l'intgrale
    int_MH(i)=mean(x(1:i).^2);
end



plot(integrale)
vrai=ones(1,n)*8.33;
hold on
plot(vrai,'k')
plot(int_MH,'r')
XLABEL('iterations')
YLABEL('intgrale')
legend('acceptation-rejet','valeur de l''intgrale','Metropolis-Hastings',0)
hold off
% print -depsc lois-gamma