function psi_out = echantillonner_psi(psi,K,p,mu,rho);

%------------------------------------------------------------------
% This function allows to sample the parameters psi
%       according to f(psi|r,p,mu,rho,y)
% 
% INPUT
%       psi     : the current state of the psi parameter
%       K       : the number of change-point in each segment
%       p       : array of the AR model orders
%       mu      : mu parameter
%       rho     : rho parameter
%
% OUTPUT
%       psi_out     : the new state of the psi parameter
%
%------------------------------------------------------------------

global J N pmax Tepsilon
global Tab_pfact


% generation of a candidate
sum_p = 0;
for j=1:J
    sum_p = sum_p + sum(p(j,1:K(j)));
end
    
psi_star = gen_gamma(mu+sum_p,rho+sum(K));

% % computation of the acceptation rate
%     C      = sum(psi.^(0:pmax)./Tab_pfact);
%     C_star = sum(psi_star.^(0:pmax)./Tab_pfact);
% 
% lambda_psi = min([1 (C/C_star * exp(psi_star-psi))^(sum(K))])
% 
% psi_out = gen_discrete([psi_star psi],[lambda_psi 1-lambda_psi],1,1);

% since the acceptation rate is very close to 1...
psi_out =psi_star;